import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Site, SiteParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageSite(params: SiteParam) {
  const res = await request.get<ApiResult<PageResult<Site>>>(
    MODULES_API_URL + '/booking/site/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listSite(params?: SiteParam) {
  const res = await request.get<ApiResult<Site[]>>(
    MODULES_API_URL + '/booking/site',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addSite(data: Site) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/site',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateSite(data: Site) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/site',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeSite(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/site/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchSite(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/site/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getSite(id: number) {
  const res = await request.get<ApiResult<Site>>(
    MODULES_API_URL + '/booking/site/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
